Unit rsa1e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, FTA2E_p, FTA3E_p;

procedure rsa1e(var ARRAY_ :Array of Extended; N :Integer;
                var RESP :Array of Extended; M :Integer;
                var ANS :Array of Complex; var FFT :Array of Complex;
                IREG :Integer; var IFLAG :Integer);

implementation

procedure rsa1e(var ARRAY_ :Array of Extended; N :Integer;
                var RESP :Array of Extended; M :Integer;
                var ANS :Array of Complex; var FFT :Array of Complex;
                IREG :Integer; var IFLAG :Integer);
var
I,M1,M1I,N1I,M3,NM1,N2,N21,_i :Integer;
_ear :Array of Extended;   //  
const
ZERO :Real = 0.0e0;
label
_10,_20,_30,_40,_50,_60;
begin
SetLength(_ear,2*(High(ANS)+1));  //   
IFLAG := 0;
M1 := Trunc( (M-1)/2 );
for I:=1 to M1 do
 begin
  N1I := N+1-I;
  M1I := M+1-I;
  RESP[N1I-1] := RESP[M1I-1];
_10:
 end;
M3 := Trunc((M+3)/2);
NM1 := N-Trunc( (M-1)/2 );
for I:=M3 to NM1 do
 begin
  RESP[I-1] := ZERO;
_20:
 end;
FTA2E(ARRAY_,RESP,FFT,ANS,N);
N2 := Trunc( N/2 );
N21 := N2+1;
for I:=1 to N21 do
 begin
  if ( IREG = 1 )
   then goto _40;
  if ( Cabs(ANS[I-1]) <> ZERO )
   then goto _30;
  IFLAG := I;
  goto _60;
_30:
  ANS[I-1] := DivC(FFT[I-1],ANS[I-1]);
  goto _50;
_40:
  ANS[I-1] := MulC(FFT[I-1],ANS[I-1]);
_50:
 end;
ANS[0] := Cmplx(Creal(ANS[0]),Creal(ANS[N2+0]));
//FTA3E(ANS,N2,-1);
for _i:=0 to High(ANS) do
 begin
  _ear[2*_i] := ANS[_i].re; //  
  _ear[2*_i + 1] := ANS[_i].im; //  
 end;
FTA3E(_ear,N2,-1);
for _i:=0 to High(ANS) do
 begin
 ANS[_i].re := _ear[2*_i]; //  
 ANS[_i].im := _ear[2*_i + 1]; //  
end;
_60:
end;

end.
